<?php
/*
 * $Id: icl_content.block.inc
 * 
 * @file ICanLocalize content block handling
 */

function icl_content_save_block_translation($bid, $code, $data) {
  $block_original = block_box_get($bid);
  
  foreach ($data as $item) {
    if ($item['type'] == 'title') {
      $title = $item['data'];
      
      // find the original in the locales_source
      
      $query = db_query("SELECT lid FROM {locales_source} WHERE source = '%s' and textgroup = 'blocks'", $item['original_data']);
      while ($result = db_fetch_array($query)) {
        $lid = $result['lid'];
      
        if(!empty($lid)) {
          icl_content_update_locale_translation($lid, $code, $title);
        } else {
          watchdog ( 'icl_content', 'Nonexistent originating block title ' . $block_original['info'], WATCHDOG_ERROR );
          //return FALSE;
          // Don't return false as the user may have changed the original text of the block and that is the reason it can't be found.
        }
      }
    }
    if ($item['type'] == 'Block titles') {
      foreach($item['data'] as $index => $title) {
        
        // find the original in the locales_source
        
        $query = db_query("SELECT lid FROM {locales_source} WHERE source = '%s' and textgroup = 'blocks'", $item['original_data'][$index]);
        while ($result = db_fetch_array($query)) {
          $lid = $result['lid'];
        
          if(!empty($lid)) {
            icl_content_update_locale_translation($lid, $code, $title);
          } else {
            watchdog ( 'icl_content', 'Nonexistent originating block title ' . $block_original['info'], WATCHDOG_ERROR );
            //return FALSE;
            // Don't return false as the user may have changed the original text of the block and that is the reason it can't be found.
          }
        }
      }
    }
    if ($item['type'] == 'body') {
      $all_links_fixed = FALSE;
      $body = _icl_content_fix_links_in_body($item['data'], "en", $code, $all_links_fixed);

      $query = db_query("SELECT lid FROM {locales_source} WHERE source = '%s' and textgroup = 'blocks'", $block_original['body']);
      while ($result = db_fetch_array($query)) {
        $lid = $result['lid'];

        if(!empty($lid)) {
          icl_content_update_locale_translation($lid, $code, $body);
        } else {
          watchdog ( 'icl_content', 'Nonexistent originating block body ' . $block_original['body'], WATCHDOG_ERROR );
          //return FALSE;
          // Don't return false as the user may have changed the original text of the block and that is the reason it can't be found.
        }
      }
    }
  }
  
  return TRUE;
}


/**
 * calculate the md5 value of a block using title and body and other data.
 *
 */

function icl_content_calculate_block_md5($block) {
  $data = _icl_content_extract_block($block);
  
  return icl_content_calculate_md5_from_data($data);
  
}

function _icl_content_is_block_translation_in_progess($block) {
  $rid = db_result(db_query("SELECT rid FROM {icl_block_status} where bid='%d'", $block['bid']));
  
  if($rid === FALSE) {
    return FALSE;
  }
  
  $result = db_result(db_query("SELECT * FROM {icl_core_status} where rid='%d' and status <> '%d'", $rid, ICL_STATUS_SUCCESSFUL));
  
  return $result !== FALSE;
}

function _icl_content_is_block_i18n_enabled($block) {
  $bid = db_result(db_query("SELECT ibid FROM {i18n_blocks} WHERE delta = %d", $block['bid']));
  
  return $bid !== FALSE;
}

function _icl_content_is_block_i18n_with_translation($block) {
  $language = db_result(db_query("SELECT language FROM {i18n_blocks} WHERE delta = %d", $block['bid']));
  
  return $language == "";
}

/**
 * Sends blocks off for translation
 *
 * @param object $block
 * @return array
 */
  
function icl_content_translate_blocks($blocks, $source_lang, $dest_langs) {
  
  foreach($blocks as $bid) {
    $block = block_box_get($bid);
    
    $targets = _icl_get_langs_not_in_progress($bid, 'block', $block, $source_lang, $dest_langs);

    if (sizeof($targets) == 0) {
      continue;
    }
    
    if (!_icl_content_is_block_i18n_enabled($block)) {
      drupal_set_message ( t ( 'error: The block is not managed by i18n block module. !block', array('!block' => $block['info'])), 'error');
      continue;
    }
    if (!_icl_content_is_block_i18n_with_translation($block)) {
      drupal_set_message ( t ( 'error: The block is not set to All languages (with translations). !block', array('!block' => $block['info'])), 'error');
      continue;
    }
    
    // Have we translated this before.
    
    $block_md5 = icl_content_calculate_block_md5($block);

    $langs = icl_core_available_languages ();
    $langs_targets = _icl_core_available_targets_for_origin ( $source_lang );

    $previous_rids = icl_content_get_rids($bid, 'block');

    $targets = _icl_content_get_langs_needing_update($targets, $langs_targets, $previous_rids, 'block', $block_md5);

    if (count ( $targets )) {
      $origin = $langs [$source_lang];
      $data = _icl_content_extract_block($block);
      
      // create a separate cms_request for each language if possible
      // if the languages have previously been sent as a combined cms_request
      // we need to do the same this time.
      
      $grouped_targets = _icl_group_targets_by_rid($bid, 'block', $source_lang, $targets, $previous_rids);
      
      foreach($grouped_targets as $lang_target){
        $previous_rid = $previous_rids[$lang_target[0]->code];
        if(!$previous_rid){
          $previous_rid = false;
        }

        if (count ( $lang_target )) {
          if ($previous_rid === FALSE) {
            // New request
            
            $rid = icl_core_add_request ( 'icl_content', $data, $origin, $lang_target, FALSE, "", $block['info'] );
          } else {
            $rid = icl_core_add_request ( 'icl_content', $data, $origin, $lang_target, $previous_rid, "", $block['info'] );
          }
            
          if ($rid != 0) {
            
            db_query ( "INSERT INTO {icl_block_status} VALUES(%d, %d, %d, '%s')", $rid, $block['bid'], time (), $block_md5 );
            db_query ( "INSERT INTO {icl_block} VALUES(%d, '%s', '%d')", $block['bid'], $block_md5, FALSE );
            $langnames = array ();
            
            foreach ( $lang_target as $target ) {
              $langnames [] = $target->name;
            }
            drupal_set_message ( t ( 'Translation request was sent to ICanLocalize for the following languages: %langs', array (
                '%langs' => implode ( ', ', $langnames ) ) ) );
          } else {
            drupal_set_message ( t ( 'error: Failed to send the translation request to the ICanLocalize server. Could not connect.'), 'error');
          }
        }
      }
    }
  }
}
    

/**
 * Extracts valuable data from a block object.
 *
 * @param object $block
 * @return array
 */
function _icl_content_extract_block($block) {
  $query = db_query("SELECT title FROM {blocks} WHERE delta = %d", $block['bid']);
  $title = array();
  while ($result = db_fetch_array($query)) {
    if (strlen($result['title']) > 0 && !in_array($result['title'], $title)) {
      $title[] = $result['title'];
    }
  }
  
  $data = array (
      array (
          'type' => 'bid', 
          'translate' => 0, 
          'text' => $block['bid'] ), 
      array (
          'type' => 'body', 
          'translate' => 1, 
          'text' => $block['body']),
      );

  if (sizeof($title) == 1) {
    $data[] = array (
          'type' => 'title', 
          'translate' => 1, 
          'text' => $title[0]);
  } else if (sizeof($title) > 1) {
    $data[] = array (
          'type' => 'Block titles', 
          'translate' => 1, 
          'text' => $title,
          'format' => 'csv');
    
  }
  
  return $data;
}

function _icl_content_get_block_title($block_data) {
  $block_title = _('(no title)');
  foreach($block_data as $data) {
    if ($data['type'] == 'title') {
      $block_title = $data['text'];
    }
  }
  
  return $block_title;
}